# SoSFEnum Class Reference
[Field classes]

`#include <Inventor/fields/SoSFEnum.h>`

Inheritance diagram for SoSFEnum:

List of all members.

## Detailed Description

The SoSFEnum class is a container for an enum value.

This field is used where nodes, engines or other field containers needs to store one particular value out of an enumerated set.

A field of this type stores its value to file as the symbolic name, rather than the actual integer value.

See also:
  SoMFEnum

## Public Member Functions

void | setValue (const SbName name)
void | setEnums (const int num, const int *vals, const SbName *names)
int | getNumEnums (void) const
int | getEnum (const int idx, SbName &name) const

## Static Public Member Functions

void | initClass (void)

## Protected Member Functions

virtual SbBool | findEnumValue (const SbName &name, int &val)
virtual SbBool | findEnumName (int value, const SbName *&name) const

## Protected Attributes

int | numEnums
int * | enumValues
SbName * | enumNames
SbBool | legalValuesSet

## Member Function Documentation

void SoSFEnum::initClass | ( | void |  | ) | `[static]`

| Internal method called upon initialization of the library (from SoDB::init()) to set up the type system. Reimplemented from SoSField. Reimplemented in SoSFBitMask.

void SoSFEnum::setValue | ( | const SbName | name | ) |

| Set the value of this field by specifying an enumeration string value.

void SoSFEnum::setEnums | ( | const int | num,
|  | const int * | vals,
|  | const SbName * | names
| ) |

| Makes a set of num enumeration names map to integer values, given by vals.

int SoSFEnum::getNumEnums | ( | void |  | ) | const

Returns the number of enum names the SoSFEnum object understands.

Note that this API method is not part of the original SGI Inventor 2.1 API, and is an extension specific to Coin.

This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

Since:
  Coin 2.0

int SoSFEnum::getEnum | ( | const int | idx,
|  | SbName & | name
| ) | const

Returns the value of the Nth enum this SoSFEnum object understands, and mutates name to contain the Nth enum's name.

Note that this API method is not part of the original SGI Inventor 2.1 API, and is an extension specific to Coin.

This function is an extension for Coin, and it is not available in the original SGI Open Inventor v2.1 API.

Since:
  Coin 2.0

SbBool SoSFEnum::findEnumValue | ( | const SbName & | name,
|  | int & | val
| ) | `[protected, virtual]`

| Return in val the enumeration value which matches the given enumeration name. Returns `TRUE` if name is a valid enumeration string, otherwise `FALSE`.

SbBool SoSFEnum::findEnumName | ( | int | value,
|  | const SbName *& | name
| ) | const`[protected, virtual]`

| Set the enumeration name which matches the given enumeration value. Returns `TRUE` if value is a valid enumeration value, otherwise `FALSE`.

## Member Data Documentation

int SoSFEnum::numEnums`[protected]`

| Number of enumeration mappings.

int * SoSFEnum::enumValues`[protected]`

| Array of enumeration values. Maps 1-to-1 with the enumNames.

SbName * SoSFEnum::enumNames`[protected]`

| Array of enumeration names. Maps 1-to-1 with the enumValues.

SbBool SoSFEnum::legalValuesSet`[protected]`

| Is `TRUE` if a set of enum name-to-value mappings has been set.

The documentation for this class was generated from the following files:

- SoSFEnum.h
- SoSFEnum.cpp